from abb.env import env
from abb.jsonld import get_context_url
from pyld import jsonld
from sparqltools.client import TornadoClient
from tornado.gen import coroutine


class VirtuosoClient(TornadoClient):
    def __init__(self):
        port = env('VIRTUOSO_PORT_8890_TCP_PORT')
        addr = env('VIRTUOSO_PORT_8890_TCP_ADDR')
        endpoint = "http://%s:%s/sparql" % (addr, port)
        super().__init__(
            endpoint,
            endpoint,
            env('DEFAULT_GRAPH_URI'),
            dump_dir=env('DUMP_DIR')
        )

    @coroutine
    def query_jsonld(self, query):
        response = yield self._client.send_query(query, "jsonld")
        document = jsonld.compact(response, get_context_url())
        return document

