import uuid

from rdflib.term import URIRef
from sparqltools.query import QueryBuilder, NSManager


def mailto(email):
    email = email.lower().strip()
    ref = "mailto:%s" % email
    return URIRef(ref)


def urn(urn_type, urn_value):
    value = "urn:%s:%s" % (urn_type, urn_value)
    value = URIRef(value)
    return value


def uuid_urn(uuid_value=None):
    if not uuid_value:
        uuid_value = str(uuid.uuid4())
    return urn("uuid", uuid_value)


class SPARQL(QueryBuilder):
    def __init__(self):
        super().__init__(NSManager.shared())


class CustomString(object):
    def __init__(self, value):
        self._value = str(value)

    def __eq__(self, other):
        if type(self) != type(other):
            return False
        return str(self) == str(other)

    def __ne__(self, other):
        return not self.__eq__(other)

    def __str__(self):
        return self._value

    def __reduce__(self):
        return (self.__class__, (str(self),))

    def __repr__(self):
        return "%s(%s)" % (self.__class__.__name__, repr(self._value))
